/// <reference types="cypress" />

describe("game should", () => {
  it("do undo and restart level 1", () => {
    cy.visit("/")
    cy.get(".level").contains("0").click()
    cy.get(".level").first().should("be.visible").click()

    cy.get(".div0.hole").should("be.visible")
    cy.get(".div2.pole").should("be.visible")
    cy.get(".div5.pole").should("be.visible").click()
    cy.get(".div5.pick").should("be.visible")
    cy.get(".div0.dest").should("be.visible").click()
    cy.get(".div2.hole").should("be.visible")
    cy.get(".div5.hole").should("be.visible")
    cy.get(".div0.pole").should("be.visible").click()
    cy.get(".div1.pole").should("be.visible")
    cy.get(".div3.dest").should("be.visible").click()
    cy.get(".div3.pole").should("be.visible")
    cy.get(".div0.hole").should("be.visible")
    cy.get(".div1.hole").should("be.visible")
    cy.get(".undo").click()
    cy.get(".div3.pole").should("be.visible")
    cy.get(".div1.pole").should("be.visible")
    cy.get(".div0.hole").should("be.visible")
    cy.get(".restart").click()
    cy.get(".div2.pole").should("be.visible")
  })

  it("lose level 7", () => {
    cy.visit("/")
    cy.get(".level").contains("7").click()
    cy.get("[data-cy=gameover]").as("gameover").should("not.be.visible")

    cy.get(".div3.pole").click()
    cy.get(".div0.dest").click()
    cy.get(".div5.pole").click()
    cy.get(".div3.dest").click()
    cy.get(".div13.pole").click()
    cy.get(".div4.dest").click()
    cy.get(".div11.pole").click()
    cy.get(".div13.dest").click()
    cy.get(".div14.pole").click()
    cy.get(".div5.dest").should("be.visible")
    cy.get(".div12.dest").click()
    cy.get(".div6.pole").click()
    cy.get(".div1.dest").click()
    cy.get(".div0.pole").click()
    cy.get(".div3.dest").click()
    cy.get(".div2.pole").click()
    cy.get(".div7.dest").click()

    cy.get("@gameover").should("be.be.visible")
  })

  it("win level 7", () => {
    cy.visit("/")
    cy.get("[data-cy=victory]").as("victory").should("not.be.visible")
    cy.get(".level").contains("10").click()

    cy.get(".div11.pole").click()
    cy.get(".div4.dest").click()
    cy.get(".div9.pole").click()
    cy.get(".div7.dest").click()
    cy.get(".div1.pole").click()
    cy.get(".div8.dest").click()
    cy.get(".div2.pole").click()
    cy.get(".div9.dest").click()
    cy.get(".div6.pole").click()
    cy.get(".div1.dest").click()
    cy.get(".div0.pole").click()
    cy.get(".div3.dest").click()
    cy.get(".div13.pole").click()
    cy.get(".div11.dest").click()
    cy.get(".div3.pole").click()
    cy.get(".div12.dest").click()
    cy.get(".div11.pole").click()
    cy.get(".div13.dest").click()
    cy.get(".div14.pole").click()
    cy.get(".div5.dest").click()
    cy.get(".div5.pole").click()
    cy.get(".div12.dest").click()
    cy.get(".div13.pole").click()
    cy.get(".div11.dest").click()
    cy.get(".div10.pole").click()
    cy.get(".div12.dest").click()

    cy.get("@victory").should("be.visible")
  })
})
